﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Globalization;

namespace vt4
{
    class PositiveNumberRule : ValidationRule
    {
        public override ValidationResult Validate(object value, System.Globalization.CultureInfo cultureInfo)
        {
            int luku = 0;
            try
            {
                luku = Convert.ToInt16(value); ;
            }
            catch (FormatException)
            {
                return new ValidationResult(false, "Value is not a valid integer.");
            }
            if (luku <= 0)
            {
                return new ValidationResult(false, "Please enter a positive integer.");
            }
            else
            {
                return ValidationResult.ValidResult;
            }
        }
    }

    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    /// 

    public partial class MainWindow : Window
    {
        TextBox malliTextBox = new TextBox();
        public int testi = 0;
        public MainWindow()
        {
            InitializeComponent();

            malliTextBox.Width = 100;
            malliTextBox.Height = 30;
            malliTextBox.HorizontalAlignment = System.Windows.HorizontalAlignment.Left;
            malliTextBox.VerticalAlignment = System.Windows.VerticalAlignment.Bottom;
            panel.Children.Add(malliTextBox);
            malliTextBox.Text = "-500";

            Binding myBinding = new Binding();
            myBinding.Source = this; // MainWindow tietolähteeksi
            myBinding.Path = new System.Windows.PropertyPath("Laskuri"); // viitataan Laskuri-propertyyn
            myBinding.Mode = BindingMode.TwoWay;
            myBinding.UpdateSourceTrigger = UpdateSourceTrigger.LostFocus; 
            // bindataan malliTextBoxin Text-ominaisuus
            myBinding.ValidationRules.Add(new PositiveNumberRule());

            malliTextBox.SetBinding(TextBox.TextProperty, myBinding);
 
            Laskuri = 534;

        }

        private void MenuItem_Click(object sender, RoutedEventArgs e)
        {
            Window1 w = new Window1();
            w.ShowDialog();
        }

        // nimeäminen tehtävä juuri seuraavalla tavalla
        public static readonly DependencyProperty LaskuriProperty =
         DependencyProperty.Register(
           "Laskuri",
           typeof(int), // propertyn tietotyyppi
           typeof(MainWindow), // luokka jossa property sijaitsee
           new FrameworkPropertyMetadata(0,  // propertyn oletusarvo
              FrameworkPropertyMetadataOptions.SubPropertiesDoNotAffectRender, 
              new PropertyChangedCallback(OnValueChanged),  // kutsutaan propertyn arvon muuttumisen jälkeen
              new CoerceValueCallback(MuutaLaskuria))); // kutsutaan ennen propertyn arvon muutosta

        // seuraavat tehtävä juuri näin. Ei mitään tarkistuksien lisäämistä
        public int Laskuri
        {
            get { return (int)GetValue(LaskuriProperty); }
            set { SetValue(LaskuriProperty, value); }
        }

        // tätä kutsutaan ennen laskurin muuttamista ja voidaan tässä vaiheessa
        // tehdä tarkistuksia ja muuttaa laskuriin asetettavaa arvoa
        private static object MuutaLaskuria(DependencyObject element, object value)
        {
            int luku = (int)value;
            if (luku < 0) value = 0;

            return luku;
        }

        private static void OnValueChanged(DependencyObject obj, DependencyPropertyChangedEventArgs args)
        {
            // ei tarvita?
        }






        // yritetty toteuttaa Inotifypropertychanged mutta ei jostain syystä toimi
        public static readonly DependencyProperty FoobarProperty =
         DependencyProperty.Register(
           "Foobar",
           typeof(LaskuriTyyppi), // propertyn tietotyyppi
           typeof(MainWindow), // luokka jossa property sijaitsee
           new FrameworkPropertyMetadata(new LaskuriTyyppi(0)  // propertyn oletusarvo
               )); 

        // jos ohjelma kaatuu kummalliseen virheilmoitukseen tyyliin:
        // {"'The invocation of the constructor on type 'foobar.MainWindow' that matches the specified binding constraints threw an exception.' Line number '3' and line position '65'."}
        // niin apua löytyy sivuilta:
        // http://wilberbeast.com/2011/06/03/wpf-common-dependency-property-exception/
        // http://stackoverflow.com/questions/1168648/why-would-a-dependency-property-implementation-crash-my-application-when-i-provi
        // pikakorjauksena kannattaa säätää Debug|Exceptions|Common Language Runtime Exceptions-riville ruksi Thrown-sarakkeeseen
        // ja ajaa ohjelma sen jälkeen uudelleen. Ruksi kannattaa taas poistaa ongelman löytymisen jälkeen
        
        // seuraavat tehtävä juuri näin. Ei mitään tarkistuksien lisäämistä
        public int Foobar
        {
            get { return (int)GetValue(FoobarProperty); }
            set { SetValue(FoobarProperty, value); }
        }
    }
        // kts. http://msdn.microsoft.com/en-us/library/ms743695.aspx
        // This class implements INotifyPropertyChanged
        // to support one-way and two-way bindings
        // (such that the UI element updates when the source
        // has been changed dynamically)
        public class LaskuriTyyppi : System.ComponentModel.INotifyPropertyChanged
        {
            private int p_laskuri = 0;
            // Declare the event
            public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;

            private LaskuriTyyppi()
            {
            }

            public LaskuriTyyppi(int value)
            {
                laskuri = value;
            }

            public int laskuri
            {
                get { return p_laskuri; }
                set
                {
                    p_laskuri = value;
                    // Call OnPropertyChanged whenever the property is updated
                    OnPropertyChanged("laskuri");
                }
            }

            // Create the OnPropertyChanged method to raise the event
            protected void OnPropertyChanged(string name)
            {
                System.ComponentModel.PropertyChangedEventHandler handler = PropertyChanged;
                if (handler != null)
                {
                    handler(this, new System.ComponentModel.PropertyChangedEventArgs(name));
                }
            }
        }

       
    
}
